/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.tajo.cli.tsql.commands;

import org.apache.tajo.cli.tsql.TajoCli;

public class CopyrightCommand extends TajoShellCommand {
  public CopyrightCommand(TajoCli.TajoCliContext context) {
    super(context);
  }

  @Override
  public String getCommand() {
    return "\\copyright";
  }

  @Override
  public void invoke(String[] cmd) throws Exception {
    context.getOutput().println();
    context.getOutput().println(
        "  Licensed to the Apache Software Foundation (ASF) under one\n" +
            "  or more contributor license agreements.  See the NOTICE file\n" +
            "  distributed with this work for additional information\n" +
            "  regarding copyright ownership.  The ASF licenses this file\n" +
            "  to you under the Apache License, Version 2.0 (the\n" +
            "  \"License\"); you may not use this file except in compliance\n" +
            "  with the License.  You may obtain a copy of the License at\n" +
            "\n" +
            "       http://www.apache.org/licenses/LICENSE-2.0\n" +
            "\n" +
            "   Unless required by applicable law or agreed to in writing, software\n" +
            "   distributed under the License is distributed on an \"AS IS\" BASIS,\n" +
            "   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n" +
            "   See the License for the specific language governing permissions and\n" +
            "   limitations under the License.");
    context.getOutput().println();
  }

  @Override
  public String getUsage() {
    return "";
  }

  @Override
  public String getDescription() {
    return "show Apache License 2.0";
  }

}
